# Relationships

{% hint style="success" %}
This is the official documentation of the `forestadmin-agent-django` and `forestadmin-agent-flask` Python agents.
{% endhint %}

A join is used to combine rows from two or more tables, based on a related column between them.

### Declaration

In Forest Admin, relations are defined as fields and are traversable in only one direction.

### Join Types

Four join types are available: `ManyToOne`, `ManyToMany`, `OneToMany`, and `OneToOne`.

| Type       | Where are the common keys?                                                                         |
| ---------- | -------------------------------------------------------------------------------------------------- |
| ManyToOne  | `origin[foreignKey] == foreign[foreignKeyTarget]`                                                  |
| OneToMany  | `origin[originKeyTarget] == foreign[originKey]`                                                    |
| ManyToMany | `origin[originKeyTarget] == through[originKey] && though[foreignKey] == foreign[foreignKeyTarget]` |
| OneToOne   | `origin[originKeyTarget] == foreign[originKey]`                                                    |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-python/under-the-hood/data-model/relationships.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
